/* **********************************************************
 * Copyright (C) 1998-2000 VMware, Inc.
 * All Rights Reserved
 * $Id: vm_oui.h,v 1.8 2001/04/27 06:26:58 edward Exp $
 * **********************************************************/
 
#ifndef _VM_OUI_H_
#define _VM_OUI_H_

#define INCLUDE_ALLOW_USERLEVEL
#define INCLUDE_ALLOW_MODULE
#define INCLUDE_ALLOW_VMKERNEL
#include "includeCheck.h"


/*
 * Our own OUIs given by IEEE.  
 */

#define VMX86_OUI		0x005056

#define VMX86_IPONLY_OUI	0x000569

#define VMX86_OUI_SIZE	3

#define VMX86_OUI0	((uint8) (VMX86_OUI >> (VMX86_OUI_SIZE - 1) * 8))
#define VMX86_OUI1	((uint8) (VMX86_OUI >> (VMX86_OUI_SIZE - 2) * 8))
#define VMX86_OUI2	((uint8) (VMX86_OUI >> (VMX86_OUI_SIZE - 3) * 8))

#define VMX86_IPONLY_OUI0	((uint8) (VMX86_IPONLY_OUI >> (VMX86_OUI_SIZE - 1) * 8))
#define VMX86_IPONLY_OUI1	((uint8) (VMX86_IPONLY_OUI >> (VMX86_OUI_SIZE - 2) * 8))
#define VMX86_IPONLY_OUI2	((uint8) (VMX86_IPONLY_OUI >> (VMX86_OUI_SIZE - 3) * 8))

/*
 * Top 2 bits of byte 3 of MAC address
 */

#define VMX86_MAC_PREFIX		0xc0
#define VMX86_MAC_FIXED			0x00	// user assigned
#define VMX86_MAC_IPBASED		0x40	// host IP based assignment
#define VMX86_MAC_OLDIPBASED		0x80	// old host IP based assignment
#define VMX86_MAC_RANDOM		0xc0	// random assignment

/*
 * Bits left for MAC address assignment
 *
 * The explicit casts shut the compiler up. -- edward
 */

#define VMX86_MAC_BITS		22

#define VMX86_BUILD_MAC(addr, type, suffix) do {                 \
   (addr)[0] = VMX86_OUI0;                                       \
   (addr)[1] = VMX86_OUI1;                                       \
   (addr)[2] = VMX86_OUI2;                                       \
   (addr)[3] = (uint8) (( (type  )        &  VMX86_MAC_PREFIX)   \
                      | (((suffix) >> 16) & ~VMX86_MAC_PREFIX)); \
   (addr)[4] = (uint8) (suffix) >> 8;                            \
   (addr)[5] = (uint8) (suffix);                                 \
} while (0)

#endif
